﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace DIOAppCS
{
    class Program
    {
        [DllImport("DIO.dll", EntryPoint = "DIO_Version", CharSet = CharSet.Auto)]
        public static extern IntPtr DIO_Version();

        [DllImport("DIO.dll", EntryPoint = "DIO_Open", CharSet = CharSet.Auto)]
        public static extern bool DIO_Open();

        [DllImport("DIO.dll", EntryPoint = "DIO_Mode1", CharSet = CharSet.Auto)]
        public static extern void DIO_Mode1(int iMode);

        [DllImport("DIO.dll", EntryPoint = "DIO_Mode2", CharSet = CharSet.Auto)]
        public static extern void DIO_Mode2(int iMode);

        [DllImport("DIO.dll", EntryPoint = "DIO_Data1", CharSet = CharSet.Auto)]
        public static extern void DIO_Data1(int iData);

        [DllImport("DIO.dll", EntryPoint = "DIO_Data2", CharSet = CharSet.Auto)]
        public static extern void DIO_Data2(int iData);

        [DllImport("DIO.dll", EntryPoint = "DIO_Status1", CharSet = CharSet.Auto)]
        public static extern int DIO_Status1();

        [DllImport("DIO.dll", EntryPoint = "DIO_Status2", CharSet = CharSet.Auto)]
        public static extern int DIO_Status2();

        [DllImport("DIO.dll", EntryPoint = "Pin_Mode", CharSet = CharSet.Auto)]
        public static extern void Pin_Mode(int index, bool bMode);

        [DllImport("DIO.dll", EntryPoint = "Pin_Output", CharSet = CharSet.Auto)]
        public static extern void Pin_Output(int index, bool bValue);

        [DllImport("DIO.dll", EntryPoint = "Pin_Input", CharSet = CharSet.Auto)]
        public static extern bool Pin_Input(int index);

        static void Main(string[] args)
        {
            string dioVersion = Marshal.PtrToStringAnsi(DIO_Version());
            Console.WriteLine("DIO Library Version: " + dioVersion);
            bool bDIO = DIO_Open();
            if (bDIO)
            {
                TestDIO();
            }
            else
            {
                Console.WriteLine("System Error !!");
            }
        }

        private static void TestDIO()
        {
            int iData = 0;
            int iStatus = 0;
            bool bIn = false;

            // Set DIO 0 2 4 6 High, 1 3 5 7 Low
            iData = 0x55;
            DIO_Data1(iData);
            // Set DIO 8  ~ 15  Low
            iData = 0x00;
            DIO_Data2(iData);

            // Get GPIO 0 ~ 7 Status
            iStatus = DIO_Status1();
            Console.WriteLine(" Pin Status (0 ~ 7)= {0:X}", iStatus);
            // Get GPIO 0 ~ 7 Status
            iStatus = DIO_Status2();
            Console.WriteLine(" Pin Status( 8 ~ 15) = {0:X}", iStatus);
            // Set DIO 4 ~ 5 Low, 6 ~ 7 High
            Pin_Output(4, false);
            Pin_Output(5, false);
            Pin_Output(6, true);
            Pin_Output(7, true);
            // Set DIO 12 ~ 13 Low, 14 ~ 15 High
            Pin_Output(12, false);
            Pin_Output(13, false);
            Pin_Output(14, true);
            Pin_Output(15, true);

            //Get DIO  Status 
            for (int iPinCnt = 0; iPinCnt < 16; iPinCnt++)
            {
                bIn = Pin_Input(iPinCnt);
                Console.WriteLine("DIO {0} Status = {1}", iPinCnt, bIn);
            }
        }        
    }
}
