﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace DIOAppCS
{
    class Program
    {
        [DllImport("DIO.dll", EntryPoint = "DIO_Version", CharSet = CharSet.Auto)]
        public static extern IntPtr DIO_Version();

        [DllImport("DIO.dll", EntryPoint = "DIO_Open", CharSet = CharSet.Auto)]
        public static extern bool DIO_Open();

        [DllImport("DIO.dll", EntryPoint = "DIO_Mode1", CharSet = CharSet.Auto)]
        public static extern void DIO_Mode1(int iMode);

        [DllImport("DIO.dll", EntryPoint = "DIO_Mode2", CharSet = CharSet.Auto)]
        public static extern void DIO_Mode2(int iMode);

        [DllImport("DIO.dll", EntryPoint = "DIO_Data1", CharSet = CharSet.Auto)]
        public static extern void DIO_Data1(int iData);

        [DllImport("DIO.dll", EntryPoint = "DIO_Data2", CharSet = CharSet.Auto)]
        public static extern void DIO_Data2(int iData);

        [DllImport("DIO.dll", EntryPoint = "DIO_Status1", CharSet = CharSet.Auto)]
        public static extern int DIO_Status1();

        [DllImport("DIO.dll", EntryPoint = "DIO_Status2", CharSet = CharSet.Auto)]
        public static extern int DIO_Status2();

        [DllImport("DIO.dll", EntryPoint = "Pin_Mode", CharSet = CharSet.Auto)]
        public static extern void Pin_Mode(int index, bool bMode);

        [DllImport("DIO.dll", EntryPoint = "Pin_Output", CharSet = CharSet.Auto)]
        public static extern void Pin_Output(int index, bool bValue);

        [DllImport("DIO.dll", EntryPoint = "Pin_Input", CharSet = CharSet.Auto)]
        public static extern bool Pin_Input(int index);

        static void Main(string[] args)
        {
            string dioVersion = Marshal.PtrToStringAnsi(DIO_Version());
            Console.WriteLine("DIO Library Version: " + dioVersion);
            bool bDIO = DIO_Open();
            if (bDIO)
            {
                TestDIO();
            }
            else
            {
                Console.WriteLine("System Error !!");
            }
        }

        private static void TestDIO()
        {
            int iData = 0;
            int iStatus = 0;
            bool bIn = false;

            //Set DIO 0 2 High, 1, 3 Low
            iData = 0x05;
            DIO_Data1(iData);

            // Get DIO 0 ~ 7 Status
            iStatus = DIO_Status1();
            Console.WriteLine(" Pin Status = " + iStatus.ToString("X2"));

            // Set Data : 0x50, 
            // Set DIO 5, 7 Low, 4, 6 High
            Pin_Output(4, true);
            Pin_Output(5, false);
            Pin_Output(6, true);
            Pin_Output(7, false);

            // Get DIO 4 ~ 7 Status
            bIn = Pin_Input(4);
            Console.WriteLine(" DIO 4 Status = " + bIn);
            bIn = Pin_Input(5);
            Console.WriteLine(" DIO 5 Status = " + bIn);
            bIn = Pin_Input(6);
            Console.WriteLine(" DIO 6 Status = " + bIn);
            bIn = Pin_Input(7);
            Console.WriteLine(" DIO 7 Status = " + bIn);          
        }
    }
}


