﻿#include <iostream>
#include <windows.h>

typedef char* (WINAPI* LPFN_DIO_Version) (void);
typedef bool (WINAPI* LPFN_DIO_Open) (void);
typedef void (WINAPI* LPFN_DIO_Data1) (int);
typedef void (WINAPI* LPFN_DIO_Data2) (int);
typedef int  (WINAPI* LPFN_DIO_Status1) (void);
typedef int  (WINAPI* LPFN_DIO_Status2) (void);
typedef void (WINAPI* LPFN_DIO_Mode1) (int);
typedef void (WINAPI* LPFN_DIO_Mode2) (int);
typedef void (WINAPI* LPFN_Pin_Mode) (int, bool);
typedef void (WINAPI* LPFN_Pin_Output) (int, bool);
typedef bool (WINAPI* LPFN_Pin_Input) (int);


LPFN_DIO_Open DIO_Open = NULL;
LPFN_DIO_Version DIO_Version = NULL;
LPFN_DIO_Mode1 DIO_Mode1 = NULL;
LPFN_DIO_Mode1 DIO_Mode2 = NULL;
LPFN_DIO_Data1 DIO_Data1 = NULL;
LPFN_DIO_Data1 DIO_Data2 = NULL;
LPFN_DIO_Status1 DIO_Status1 = NULL;
LPFN_DIO_Status1 DIO_Status2 = NULL;
LPFN_Pin_Mode Pin_Mode = NULL;
LPFN_Pin_Output Pin_Output = NULL;
LPFN_Pin_Input Pin_Input = NULL;
HMODULE hDIO = NULL;

bool LoadDIO();
void TestDIO();

int main()
{
	if (!LoadDIO())
	{
		printf("Failed to load DLL file !\n");
		return -1;
	}

	TestDIO();

	return 0;
}

bool LoadDIO()
{
	hDIO = GetModuleHandle(TEXT("DIO.dll"));

	if (hDIO == NULL)
	{
		hDIO = LoadLibrary(TEXT("DIO.dll"));
	}

	if (hDIO == NULL)
	{
		printf("LoadLibrary Error !!\n");
		return false;
	}

	DIO_Version = (LPFN_DIO_Version)GetProcAddress(hDIO, "DIO_Version");
	printf("Version: %s", DIO_Version());

	DIO_Open = (LPFN_DIO_Open)GetProcAddress(hDIO, "DIO_Open");
	if (NULL != DIO_Open)
	{
		bool Result = DIO_Open();
		if (Result)
		{
			DIO_Mode1 = (LPFN_DIO_Mode1)GetProcAddress(hDIO, "DIO_Mode1");
			DIO_Mode2 = (LPFN_DIO_Mode2)GetProcAddress(hDIO, "DIO_Mode2");
			DIO_Data1 = (LPFN_DIO_Data1)GetProcAddress(hDIO, "DIO_Data1");
			DIO_Data2 = (LPFN_DIO_Data2)GetProcAddress(hDIO, "DIO_Data2");
			DIO_Status1 = (LPFN_DIO_Status1)GetProcAddress(hDIO, "DIO_Status1");
			DIO_Status2 = (LPFN_DIO_Status2)GetProcAddress(hDIO, "DIO_Status2");
			Pin_Mode = (LPFN_Pin_Mode)GetProcAddress(hDIO, "Pin_Mode");
			Pin_Output = (LPFN_Pin_Output)GetProcAddress(hDIO, "Pin_Output");
			Pin_Input = (LPFN_Pin_Input)GetProcAddress(hDIO, "Pin_Input");
			return true;
		}
		printf("System Error !!\n");
	}

	FreeLibrary(hDIO);
	hDIO = NULL;
	return false;
}

void TestDIO()
{
	int iData = 0;
	int iStatus = 0;
	bool bIn = false;

	// Set DIO 0 ~ 7 Output, 8 ~ 15 Input
	DIO_Mode1(0xFF);
	DIO_Mode2(0x00);

	// Set DIO 0 2 4 6 High, 1 3 5 7 Low
	iData = 0x55;
	DIO_Data1(iData);

	// Get DIO 8 ~ 15 Status
	iStatus = DIO_Status2();
	printf(" Pin Status = %2x\n", iStatus);

	// Set DIO 0 ~ 3 Input, 4 ~ 7 Output
	Pin_Mode(0, false);
	Pin_Mode(1, false);
	Pin_Mode(2, false);
	Pin_Mode(3, false);
	Pin_Mode(4, true);
	Pin_Mode(5, true);
	Pin_Mode(6, true);
	Pin_Mode(7, true);

	// Set DIO 4 ~ 5 Low, 6 ~ 7 High
	Pin_Output(4, false);
	Pin_Output(5, false);
	Pin_Output(6, true);
	Pin_Output(7, true);

	// Get DIO 0 ~ 7 Status
	for (int iPinIdx = 0; iPinIdx < 8; iPinIdx++)
	{
		bIn = Pin_Input(iPinIdx);
		printf(" DIO %d Status = %d\n", iPinIdx, bIn);
	}
}

