﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace DIOAppCS
{
    class Program
    {
        [DllImport("DIO.dll", EntryPoint = "DIO_Version", CharSet = CharSet.Auto)]
        public static extern IntPtr DIO_Version();

        [DllImport("DIO.dll", EntryPoint = "DIO_Open", CharSet = CharSet.Auto)]
        public static extern bool DIO_Open();

        [DllImport("DIO.dll", EntryPoint = "DIO_Mode1", CharSet = CharSet.Auto)]
        public static extern void DIO_Mode1(int iMode);

        [DllImport("DIO.dll", EntryPoint = "DIO_Mode2", CharSet = CharSet.Auto)]
        public static extern void DIO_Mode2(int iMode);

        [DllImport("DIO.dll", EntryPoint = "DIO_Data1", CharSet = CharSet.Auto)]
        public static extern void DIO_Data1(int iData);

        [DllImport("DIO.dll", EntryPoint = "DIO_Data2", CharSet = CharSet.Auto)]
        public static extern void DIO_Data2(int iData);

        [DllImport("DIO.dll", EntryPoint = "DIO_Status1", CharSet = CharSet.Auto)]
        public static extern int DIO_Status1();

        [DllImport("DIO.dll", EntryPoint = "DIO_Status2", CharSet = CharSet.Auto)]
        public static extern int DIO_Status2();

        [DllImport("DIO.dll", EntryPoint = "Pin_Mode", CharSet = CharSet.Auto)]
        public static extern void Pin_Mode(int index, bool bMode);

        [DllImport("DIO.dll", EntryPoint = "Pin_Output", CharSet = CharSet.Auto)]
        public static extern void Pin_Output(int index, bool bValue);

        [DllImport("DIO.dll", EntryPoint = "Pin_Input", CharSet = CharSet.Auto)]
        public static extern bool Pin_Input(int index);

        static void Main(string[] args)
        {
            string dioVersion = Marshal.PtrToStringAnsi(DIO_Version());
            Console.WriteLine("DIO Library Version: " + dioVersion);
            bool bDIO = DIO_Open();
            if (bDIO)
            {
                TestDIO();
            }
            else
            {
                Console.WriteLine("System Error !!");
            }
        }

        private static void TestDIO()
        {
            int iData = 0;
            int iStatus = 0;
            bool bIn = false;

            //iso lsolation
            //mode : 0xF0
            //DOUT3(Pin9),DOUT2(Pin8),DOUT1(Pin7),DOUT0(Pin6) 
            //DIN3(Pin4),DIN2(Pin3),DIN1(Pin2),DIN0(Pin1)  
            // Set DIO 4 ~ 5 Low, 6 ~ 7 High
            iData = 0x30;
            DIO_Data1(iData);

            // Get DIO 0 ~ 7 Status
            iStatus = DIO_Status1();
            Console.WriteLine(" Pin Status = " + iStatus.ToString("X2"));

            // Set DIO 4 ~ 5 Low, 6 ~ 7 High
            Pin_Output(4, false);
            Pin_Output(5, false);
            Pin_Output(6, true);
            Pin_Output(7, true);

            // Get DIO 0 ~ 7 Status
            bIn = Pin_Input(0);
            Console.WriteLine(" DIO 0 Status = " + bIn);
            bIn = Pin_Input(1);
            Console.WriteLine(" DIO 1 Status = " + bIn);
            bIn = Pin_Input(2);
            Console.WriteLine(" DIO 2 Status = " + bIn);
            bIn = Pin_Input(3);
            Console.WriteLine(" DIO 3 Status = " + bIn);
            bIn = Pin_Input(4);
            Console.WriteLine(" DIO 4 Status = " + bIn);
            bIn = Pin_Input(5);
            Console.WriteLine(" DIO 5 Status = " + bIn);
            bIn = Pin_Input(6);
            Console.WriteLine(" DIO 6 Status = " + bIn);
            bIn = Pin_Input(7);
            Console.WriteLine(" DIO 7 Status = " + bIn);
        }    
    }
}


